#if !defined(GENERAL_INCLUDED_)
#define GENERAL_INCLUDED_

//****************************************************************************/
// Include files
//****************************************************************************/
#include <stdint.h>
// #include <stdlib.h>
// #include <avr/io.h>
// #include <avr/interrupt.h>
// #include <avr/pgmspace.h>

//****************************************************************************/
// Defines
//****************************************************************************/
#define BOOL int8_t
#define FALSE 0
#define TRUE 1
#define IDENTICAL 0

#define MIN(a,b) ({ __typeof__ (a) _a = (a); __typeof__ (b) _b = (b); _a < _b ? _a : _b; })
#define MAX(a,b) ({ __typeof__ (a) _a = (a); __typeof__ (b) _b = (b); _a > _b ? _a : _b; })

#ifndef F_CPU
#error F_CPU is not defined! Define it in the projekt settings!!
#endif

// Quarz = 8 MHz; http://www.wormfood.net/avrbaudcalc.php
// Bit Rate    UBRR         % of error       Geeignet?
//    300      1666             0.0          UBRR out of range 
//    600       832             0.0          UBRR out of range 
//   1200       416             0.1          UBRR out of range 
//   2400       207             0.2          UBRR and clock speed are less than 1% off 
//   4800       103             0.2          UBRR and clock speed are less than 1% off 
//   9600        51             0.2          UBRR and clock speed are less than 1% off 
//  14400        34             0.8          UBRR and clock speed are less than 1% off 
//  19200        25             0.2          UBRR and clock speed are less than 1% off 
//  28800        16             2.1          UBRR and clock speed are between 2% and 3% off 
//  38400        12             0.2          UBRR and clock speed are less than 1% off 
//  57600         8             3.7          UBRR and clock speed are between 3% and 10% off
//  76800         6             7.5          UBRR and clock speed are between 3% and 10% off
// 115200         3             7.8          UBRR and clock speed are between 3% and 10% off
// 230400         1             7.8          UBRR and clock speed are between 3% and 10% off

//****************************************************************************/
// Other
//****************************************************************************/
void delay_ms(int16_t ms);
void delay_s(int16_t s);

#endif // !defined(GENERAL_INCLUDED_)
